(function() {
  "use strict";
  angular.module("KAO.currency", []).directive("currency", [
    "$filter",
    function($filter) {
      function link(scope, element, attrs, ngModel) {
        var value, symbol, arr, ollArr, content, head, style, shee, styleName;
        // 随机排序数组
        function shuffle(arr) {
          for (var i = arr.length - 1; i >= 0; i--) {
            var randomIndex = Math.floor(Math.random() * (i + 1));
            var itemAtIndex = arr[randomIndex];
            arr[randomIndex] = arr[i];
            arr[i] = itemAtIndex;
          }
          return arr;
        }
        // 随机HTML
        function html(style, value) {
          var type = Math.floor(Math.random() * (2 + 1));
          switch (type) {
            case 0:
              return "<b class=" + style + "><s>" + value + "</s></b>";
              break;
            case 1:
              return "<i class=" + style + "><s>" + value + "</s></i>";
              break;
            case 2:
              return "<span class=" + style + "><s>" + value + "</s></span>";
              break;
            default:
              return "<b class=" + style + "><s>" + value + "</s></b>";
          }
        }
        // 格式化数值
        function mathRound(number) {
          return Math.round((number + 0.00001) * 100) / 100;
        }
        // 创建样式
        function addClass(rules, selector) {
          selector = selector || randomClass();
          if (rules == undefined) {
            return selector;
          }
          if (shee.insertRule) {
            shee.insertRule("." + selector + "{" + rules + "}", 0);
          } else if (shee.addRule) {
            shee.addRule("." + sselector, rules, 0);
          }
          return selector;
        }
        // 随机样式名称
        function randomClass() {
          var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
          var maxPos = chars.length;
          var str = "";
          for (var i = 0; i < 10; i++) {
            str += chars.charAt(Math.floor(Math.random() * (maxPos + 1)));
          }
          return str;
        }
        // 创建一个 style， 返回其 stylesheet 对象
        style = document.getElementsByTagName("style")[0];
        if (style == undefined) {
          head = document.head || document.getElementsByTagName("head")[0];
          style = document.createElement("style");
          style.type = "text/css";
          head.appendChild(style);
        }
        shee = style.sheet || style.styleSheet;
        // 数值
        value = scope.$parent.$eval(attrs.ngModel);
        value = value == undefined ? 0 : value;
        value = mathRound(value);
        // 货币符号
        symbol = scope.$parent.$eval(attrs.symbol);
        symbol = symbol == undefined ? "" : symbol;
        // 格式化货币
        value = $filter("currency")(value, symbol);
        // 将货币字符串转成数组
        arr = value.split("");
        // 原始数组
        ollArr = value.split("");
        // 将货币字符串数组随机打乱
        angular.forEach(shuffle(arr), function(value, index) {
          content = ollArr[index];
          styleName = addClass();
          var cssStr = 'content:"' + content + '" !important;';
          var before = styleName + ":before";
          addClass(cssStr, before);
          angular.element(element).append(html(styleName, value));
        });
      }
      return {
        restrict: "A",
        scope: {
          ngModel: "="
        },
        link: link
      };
    }
  ]);
})();
